## k3d 0.8.0.2

=== CMakeLists.txt ===
PROJECT(k3d)

# Configure CMake ...
CMAKE_MINIMUM_REQUIRED(VERSION 2.6 FATAL_ERROR)
CMAKE_POLICY(SET CMP0003 OLD)

SET(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules")

INCLUDE(K3DOutOfSourceBuild) # Disallow in-source builds
INCLUDE(K3DGenerateDEF) # Convenience macro for linking Win32 DLLs using MSVC
INCLUDE(K3DDependencies)
INCLUDE(K3DWordSize) # Detect 32/64 bit platform
INCLUDE(K3DCompiler) # Detect problematic compilers

# Set the K-3D version
SET(K3D_MAJOR_VERSION 0)
SET(K3D_MINOR_VERSION 8)
SET(K3D_RELEASE_VERSION 0)
SET(K3D_BUILD_VERSION 2)
SET(K3D_SO_VERSION 1)

SET(K3D_PACKAGE k3d)
SET(K3D_VERSION ${K3D_MAJOR_VERSION}.${K3D_MINOR_VERSION}.${K3D_RELEASE_VERSION}.${K3D_BUILD_VERSION})
SET(K3D_HOST ${CMAKE_SYSTEM} ${CMAKE_SYSTEM_PROCESSOR})
SET(K3D_COPYRIGHT "Copyright (c) 1995-2010, Timothy M. Shead.  All Rights Reserved.")
SET(K3D_INSTALL_PREFIX ${CMAKE_INSTALL_PREFIX})

# Setup high-level build options
IF(WIN32 AND MSVC)
	SET(K3D_ENABLE_SYMBOL_VISIBILITY_DEFAULT ON)
ELSE(WIN32 AND MSVC)
	SET(K3D_ENABLE_SYMBOL_VISIBILITY_DEFAULT OFF)
ENDIF(WIN32 AND MSVC)

# Run tests to find external packages ...
INCLUDE(K3DFind3ds)
INCLUDE(K3DFindCairomm)
INCLUDE(K3DFindCARVE)
INCLUDE(K3DFindCGAL)
INCLUDE(K3DFindCollada)
INCLUDE(K3DFindDBus)
INCLUDE(K3DFindFreetype2)
INCLUDE(K3DFindGlibmm)
INCLUDE(K3DFindGMM)
INCLUDE(K3DFindGnomeVFS)
INCLUDE(K3DFindGooglePerftools)
INCLUDE(K3DFindGtkGLExt)
INCLUDE(K3DFindGtkmm)
INCLUDE(K3DFindGtkSourceView)
INCLUDE(K3DFindGTS)
INCLUDE(K3DFindImageMagick)
INCLUDE(K3DFindInotify)
INCLUDE(K3DFindIntl)
INCLUDE(K3DFindJPEG)
INCLUDE(K3DFindODE)
INCLUDE(K3DFindOpenCascade)
INCLUDE(K3DFindOpenEXR)
INCLUDE(K3DFindOpenGL)
INCLUDE(K3DFindPNG)
INCLUDE(K3DFindPython)
INCLUDE(K3DFindSigC)
INCLUDE(K3DFindSuperLU)
INCLUDE(K3DFindTBB)
INCLUDE(K3DFindTIFF)
INCLUDE(K3DFindXML)
INCLUDE(K3DFindZlib)

# Setup module enabled/disabled defaults ...
IF(WIN32)
	SET(K3D_BUILD_GLX_MODULE_DEFAULT OFF)
	SET(K3D_BUILD_OSX_MODULE_DEFAULT OFF)
	SET(K3D_BUILD_VIRTUAL_OFFSCREEN_MODULE_DEFAULT OFF)
ENDIF(WIN32)

IF(UNIX AND NOT APPLE)
	SET(K3D_BUILD_GLX_MODULE_DEFAULT OFF)
	SET(K3D_BUILD_OSX_MODULE_DEFAULT OFF)
	SET(K3D_BUILD_VIRTUAL_OFFSCREEN_MODULE_DEFAULT OFF)
ENDIF(UNIX AND NOT APPLE)

IF(APPLE)
	SET(K3D_BUILD_GLX_MODULE_DEFAULT OFF)
	SET(K3D_BUILD_OSX_MODULE_DEFAULT ON)
	SET(K3D_BUILD_VIRTUAL_OFFSCREEN_MODULE_DEFAULT OFF)
ENDIF(APPLE)

OPTION(K3D_BUILD_3DS_IO_MODULE "Build the 3ds_io plugin module" ${K3D_3DS_FOUND})
OPTION(K3D_BUILD_ADVANCED_OPENGL_PAINTERS_MODULE "Build the advanced OpenGL mesh painters module" ON)
OPTION(K3D_BUILD_ANIMATION_MODULE "Build the animation plugin module" ON)
OPTION(K3D_BUILD_ANNOTATION_MODULE "Build the annotation plugin module" ${K3D_FREETYPE2_FOUND})
OPTION(K3D_BUILD_ARRAY_MODULE "Build the array plugin module" ON)
OPTION(K3D_BUILD_BICUBIC_PATCH_MODULE "Build the bicubic patch plugin module" ON)
OPTION(K3D_BUILD_BILINEAR_PATCH_MODULE "Build the bilinear patch plugin module" ON)
OPTION(K3D_BUILD_BITMAP_MODULE "Build the bitmap plugin module" ON)
OPTION(K3D_BUILD_BLOBBY_MODULE "Build the blobby plugin module" ON)
OPTION(K3D_BUILD_BUNDLED_RENDERMAN_ENGINES_MODULE "Provides integration with RenderMan-compatible render engines that are bundled with K-3D." OFF)
OPTION(K3D_BUILD_CARVE_MODULE "Build the CARVE plugin module" ${K3D_CARVE_FOUND})
OPTION(K3D_BUILD_CGAL_MODULE "Build the CGAL plugin module" ${K3D_CGAL_FOUND})
OPTION(K3D_BUILD_CLOTH_MODULE "Build the cloth plugin module" ON)
OPTION(K3D_BUILD_COLLADA_IO_MODULE "Build the COLLADA plugin module" ${K3D_COLLADA_FOUND})
OPTION(K3D_BUILD_COMPIZ_MODULE "Build the Compiz plugin module" ${K3D_DBUS_FOUND})
OPTION(K3D_BUILD_CORE_MODULE "Build the core plugin module" ON)
OPTION(K3D_BUILD_CUDA_MODULE "Build the cuda plugin module" OFF)
OPTION(K3D_BUILD_DEFORMATION_MODULE "Build the mesh deformation plugin module" ON)
OPTION(K3D_BUILD_DEVELOPMENT_MODULE "Build the development plugin module" ON)
OPTION(K3D_BUILD_DOUBLE_MODULE "Build the double plugin module" ON)
OPTION(K3D_BUILD_EULER_OPERATIONS_MODULE "Build the module that exposes the Euler mesh operations as mesh modifiers" OFF)
OPTION(K3D_BUILD_FILE_MAGIC_MODULE "Build the file-identification-magic module" ON)
OPTION(K3D_BUILD_FREETYPE2_MODULE "Build the freetype2 plugin module" ON)
OPTION(K3D_BUILD_GLX_MODULE "Build the GLX offscreen rendering module" ${K3D_BUILD_GLX_MODULE_DEFAULT})
OPTION(K3D_BUILD_GNOME_MODULE "Build the GNOME integration plugin module" ${K3D_GNOME_VFS_FOUND})
OPTION(K3D_BUILD_GOOGLE_PERFTOOLS_MODULE "Build the Google Perftools profiling module" ${K3D_GOOGLE_PERFTOOLS_FOUND})
OPTION(K3D_BUILD_GRAPHVIZ_MODULE "Build the GraphViz integration plugin module" ON)
OPTION(K3D_BUILD_GTS_IO_MODULE "Build the GNU Triangulated Surfaces file format module" ON)
OPTION(K3D_BUILD_GTS_MODULE "Build the GNU Triangulated Surfaces plugin module" ${K3D_GTS_FOUND})
OPTION(K3D_BUILD_HIGHLIGHTING_MODULE "Build the user interface 'highlighting' plugin module" ON)
OPTION(K3D_BUILD_IMAGEMAGICK_IO_MODULE "Build the ImageMagick file format module" ${K3D_IMAGEMAGICK_FOUND})
OPTION(K3D_BUILD_INDIGO_MODULE "Build the Indigo render engine integration module" ON)
OPTION(K3D_BUILD_INOTIFY_MODULE "Build the inotify file change notification module" ${K3D_INOTIFY_FOUND})
OPTION(K3D_BUILD_JPEG_IO_MODULE "Build the jpeg file format module" ${K3D_JPEG_FOUND})
OPTION(K3D_BUILD_K3D_IO_MODULE "Build the K-3D file format module" ON)
OPTION(K3D_BUILD_LINEAR_CURVE_MODULE "Build the linear curve plugin module" ON)
OPTION(K3D_BUILD_LIPSYNC_MODULE "Build the lip synchronization tools module" ON)
OPTION(K3D_BUILD_LSYSTEM_MODULE "Build the l-system parser module" ON)
OPTION(K3D_BUILD_LUXRENDER_MODULE "Build the Luxrender render enegine integration module" ON)
OPTION(K3D_BUILD_MATRIX_MODULE "Build the matrix operations module" ON)
OPTION(K3D_BUILD_MD2_IO_MODULE "Build the md2 io plugin module" ON)
OPTION(K3D_BUILD_MESH_ATTRIBUTES_MODULE "Build the mesh attributes plugin module" ON)
OPTION(K3D_BUILD_MESH_INSTANCE_MODULE "Build the mesh-instance plugin module" ON)
OPTION(K3D_BUILD_MESH_MODULE "Build the mesh plugin module" ON)
OPTION(K3D_BUILD_NGUI_ABOUT_MODULE "Build the user interface 'about' dialog plugin module" ON)
OPTION(K3D_BUILD_NGUI_ANIMATION_TIMELINE_PANEL_MODULE "Build the experimental animation timeline panel plugin module" ON)
OPTION(K3D_BUILD_NGUI_ASSIGN_HOTKEYS_MODULE "Build the user interface 'assign hotkeys' plugin module" ON)
OPTION(K3D_BUILD_NGUI_ATK_EVENT_RECORDER_MODULE "Build the user interface ATK 'event recorder' plugin module" OFF)
OPTION(K3D_BUILD_NGUI_KNOT_VECTOR_CONTROL_MODULE "Build the custom knot-vector property control plugin module" ON)
OPTION(K3D_BUILD_NGUI_LEARNING_MODULE "Build the user interface learning (tutorial) dialog plugin module" ON)
OPTION(K3D_BUILD_NGUI_LOG_MODULE "Build the user interface log window plugin module" ON)
OPTION(K3D_BUILD_NGUI_MATERIAL_MANAGER_PANEL_MODULE "Build the user interface manager manager panel plugin module" OFF)
OPTION(K3D_BUILD_NGUI_MESH_CONTROL_MODULE "Build the mesh property control plugin module" ON)
OPTION(K3D_BUILD_NGUI_MODULE "Build the standard graphical user interface plugin module" ON)
OPTION(K3D_BUILD_NGUI_MORPH_POINTS_PAGE_MODULE "Build the MorphPoints custom property page module" ON)
OPTION(K3D_BUILD_NGUI_NODE_HISTORY_PANEL_MODULE "Build the user interface node history panel plugin module" ON)
OPTION(K3D_BUILD_NGUI_NODE_LIST_PANEL_MODULE "Build the user interface node list panel plugin module" ON)
OPTION(K3D_BUILD_NGUI_NODE_PROPERTIES_PANEL_MODULE "Build the user interface node properties panel plugin module" ON)
OPTION(K3D_BUILD_NGUI_OPENGL_DIALOG_MODULE "Build the user interface OpenGL information dialog plugin module" ON)
OPTION(K3D_BUILD_NGUI_PARENT_TOOL_MODULE "Build the user interface 'parent tool' plugin module" ON)
OPTION(K3D_BUILD_NGUI_PIPELINE_PANEL_MODULE "Build the user interface pipeline display panel plugin module" ON)
OPTION(K3D_BUILD_NGUI_PIPELINE_PROFILER_PANEL_MODULE "Build the user interface pipeline profiler panel plugin module" ON)
OPTION(K3D_BUILD_NGUI_PYTHON_SHELL_MODULE "Build the interactive Python shell plugin module" ON)
OPTION(K3D_BUILD_NGUI_RECTANGLE_CONTROL_MODULE "Build the custom rectangle property control plugin module" ON)
OPTION(K3D_BUILD_NGUI_RENDER_REGION_TOOL_MODULE "Build the user interface 'render region tool' plugin module" ON)
OPTION(K3D_BUILD_NGUI_SELECTION_CONTROL_MODULE "Build the selection property control plugin module" ON)
OPTION(K3D_BUILD_NGUI_SNAP_TOOL_MODULE "Build the user interface 'snap tool' plugin module" ON)
OPTION(K3D_BUILD_NGUI_SPACE_NAVIGATOR_MODULE "Build the SpaceNavigator 3D mouse integration module" OFF)
OPTION(K3D_BUILD_NGUI_TEXT_EDITOR_MODULE "Build the user interface text editor plugin module" ON)
OPTION(K3D_BUILD_NGUI_TIMELINE_PANEL_MODULE "Build the user interface timeline panel plugin module" ON)
OPTION(K3D_BUILD_NGUI_TOOLBAR_PANEL_MODULE "Build the user interface toolbar panel plugin module" ON)
OPTION(K3D_BUILD_NGUI_TOOL_PROPERTIES_PANEL_MODULE "Build the user interface tool properties panel plugin module" ON)
OPTION(K3D_BUILD_NGUI_UNDO_TREE_PANEL_MODULE "Build the user interface undo panel plugin module" ON)
OPTION(K3D_BUILD_NGUI_UV_EDITOR_PANEL_MODULE "Build the user interface UV editor panel plugin module" OFF)
OPTION(K3D_BUILD_NUI_MODULE "Build the Null User Interface module" ON)
OPTION(K3D_BUILD_NURBS_MODULE "Build the NURBS plugin module" ON)
OPTION(K3D_BUILD_NURBS_SOURCES_MODULE "Build the NURBS sources plugin module" ON)
OPTION(K3D_BUILD_OBJ_IO_MODULE "Build the Wavefront .obj file format module" ON)
OPTION(K3D_BUILD_ODE_MODULE "Build the Open Dynamics Engine (ODE) integration module" ${K3D_ODE_FOUND})
OPTION(K3D_BUILD_OGRE_IO_MODULE "Build the Object-oriented Graphics Engine (OGRE) file I/O module" ON)
OPTION(K3D_BUILD_OPENCASCADE_MODULE "Build the OpenCascade module" ${K3D_OPENCASCADE_FOUND})
OPTION(K3D_BUILD_OPENEXR_IO_MODULE "Build the OpenEXR file format module" ${K3D_OPENEXR_FOUND})
OPTION(K3D_BUILD_OPENGL_MODULE "Build the OpenGL integration module" ON)
OPTION(K3D_BUILD_OSX_MODULE "Build the Mac OSX integration plugin module" ${K3D_BUILD_OSX_MODULE_DEFAULT})
OPTION(K3D_BUILD_PARTICLE_MODULE "Build the point group plugin module" ON)
OPTION(K3D_BUILD_PDIFF_MODULE "Build the perceptual-diff plugin module" ON)
OPTION(K3D_BUILD_PIXIE_MODULE "Build the Pixie render engine integration module" ON)
OPTION(K3D_BUILD_PLOT_MODULE "Build the function-plot module" ON)
OPTION(K3D_BUILD_PLY_IO_MODULE "Build the Stanford .ply file format module" ON)
OPTION(K3D_BUILD_PNG_IO_MODULE "Build the PNG file format module" ON)
OPTION(K3D_BUILD_POLYHEDRON_MODULE "Build the polyhedron plugin module" ON)
OPTION(K3D_BUILD_POLYHEDRON_SOURCES_MODULE "Build the polyhedron sources module" ON)
OPTION(K3D_BUILD_PYTHON_MODULE "Build the Python scripting language module" ON)
OPTION(K3D_BUILD_PYUI_MODULE "Build the Python user interface plugin" ON)
OPTION(K3D_BUILD_QSLIM_MODULE "Build the qslim module" ON)
OPTION(K3D_BUILD_QUADRICS_MODULE "Build the quadrics module" ON)
OPTION(K3D_BUILD_REFERENCE_OPENGL_PAINTERS_MODULE "Build the reference OpenGL mesh painters module" ON)
OPTION(K3D_BUILD_RENDERMAN_ENGINES_MODULE "Provides integration with many RenderMan-compatible render engines." ON)
OPTION(K3D_BUILD_RENDERMAN_MODULE "Build the RenderMan integration module" ON)
OPTION(K3D_BUILD_RENDERMAN_PAINTERS_MODULE "Build the RenderMan mesh painters module" ON)
OPTION(K3D_BUILD_RELEASE_MODULE "Build the release nag-messages module" ON)
OPTION(K3D_BUILD_SCRIPTED_PLUGINS_MODULE "Build the scripted plugins module" ON)
OPTION(K3D_BUILD_SCRIPTING_MODULE "Build the scripting plugin module" ON)
OPTION(K3D_BUILD_SELECTION_MODULE "Build the selection plugin module" ON)
OPTION(K3D_BUILD_SOLAR_MODULE "Build the solar plugin module" ON)
OPTION(K3D_BUILD_STL_IO_MODULE "Build the STL file format module" ON)

=== application/CMakeLists.txt ===
PROJECT(application)

INCLUDE_DIRECTORIES(${k3d_SOURCE_DIR})
INCLUDE_DIRECTORIES(${k3dsdk_BINARY_DIR})
INCLUDE_DIRECTORIES(${K3D_BOOST_INCLUDE_DIRS})
INCLUDE_DIRECTORIES(${K3D_GLIBMM_INCLUDE_DIRS})
INCLUDE_DIRECTORIES(${K3D_SIGC_INCLUDE_DIRS})

LINK_DIRECTORIES(${K3D_BOOST_LIB_DIRS})
LINK_DIRECTORIES(${K3D_SIGC_LIB_DIRS})

SET(SOURCES k3d_main.cpp)

IF(WIN32 AND MSVC)
	SET(SOURCES ${SOURCES} winmain.cpp)
ELSE(WIN32 AND MSVC)
	SET(SOURCES ${SOURCES} main.cpp)
ENDIF(WIN32 AND MSVC)

IF(WIN32)
	IF(MINGW)
		ADD_CUSTOM_COMMAND(
			OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/icon.o
			COMMAND
				windres.exe
				-I${CMAKE_CURRENT_SOURCE_DIR}
				-i${CMAKE_CURRENT_SOURCE_DIR}/icon.rc
				-o ${CMAKE_CURRENT_BINARY_DIR}/icon.o
			)

		SET(SOURCES ${SOURCES} ${CMAKE_CURRENT_BINARY_DIR}/icon.o)
	ELSE(MINGW)
		SET(SOURCES ${SOURCES} icon.rc)
	ENDIF(MINGW)
ENDIF(WIN32)

ADD_EXECUTABLE(k3d WIN32 ${SOURCES})
TARGET_LINK_LIBRARIES(k3d k3dsdk)
TARGET_LINK_LIBRARIES(k3d ${K3D_BOOST_PROGRAM_OPTIONS_LIBS})

IF(UNIX AND NOT APPLE)
	SET_TARGET_PROPERTIES(k3d PROPERTIES LINK_FLAGS -Wl,-E)
ENDIF()

IF(K3D_ENABLE_NLS)
	INCLUDE_DIRECTORIES(${K3D_INTL_INCLUDE_DIRS})
	TARGET_LINK_LIBRARIES(k3d ${K3D_INTL_LIBS})
ENDIF(K3D_ENABLE_NLS)

SET(K3D_NGUI_BINARY ${k3d_BINARY_DIR}/${K3D_LIBDIR}/k3d/plugins/k3d-ngui.module)
SET(K3D_NUI_BINARY ${k3d_BINARY_DIR}/${K3D_LIBDIR}/k3d/plugins/k3d-nui.module)
SET(K3D_PYUI_BINARY ${k3d_BINARY_DIR}/${K3D_LIBDIR}/k3d/plugins/k3d-pyui.module)

SET(K3D_DEFAULT_ARGUMENTS "")
LIST(APPEND K3D_DEFAULT_ARGUMENTS "--color")
LIST(APPEND K3D_DEFAULT_ARGUMENTS "--log-level=debug")
LIST(APPEND K3D_DEFAULT_ARGUMENTS "--plugins=${k3d_BINARY_DIR}/${K3D_LIBDIR}/k3d/plugins")
LIST(APPEND K3D_DEFAULT_ARGUMENTS "--share=${k3d_SOURCE_DIR}/share")
LIST(APPEND K3D_DEFAULT_ARGUMENTS "--add-path=${k3d_BINARY_DIR}/bin")
LIST(APPEND K3D_DEFAULT_ARGUMENTS "--locale=${k3d_BINARY_DIR}/po")

SET(K3D_EXTRA_GDB_ARGUMENTS "" CACHE STRING "Extra arguments to pass to gdb for debugging.")
MARK_AS_ADVANCED(K3D_EXTRA_GDB_ARGUMENTS)

ADD_CUSTOM_TARGET(run-nui
	COMMAND ${k3d_BINARY_DIR}/bin/k3d ${K3D_DEFAULT_ARGUMENTS} --ui=${K3D_NUI_BINARY}
	)

ADD_CUSTOM_TARGET(run-gdb-nui
	COMMAND gdb ${K3D_EXTRA_GDB_ARGUMENTS} --args ${k3d_BINARY_DIR}/bin/k3d ${K3D_DEFAULT_ARGUMENTS} --ui=${K3D_NUI_BINARY}
	)

IF(K3D_BUILD_NGUI_MODULE)
	ADD_CUSTOM_TARGET(run
		COMMAND ${k3d_BINARY_DIR}/bin/k3d ${K3D_DEFAULT_ARGUMENTS} --ui=${K3D_NGUI_BINARY}
		)

	ADD_CUSTOM_TARGET(run-gdb
		COMMAND gdb ${K3D_EXTRA_GDB_ARGUMENTS} --args ${k3d_BINARY_DIR}/bin/k3d ${K3D_DEFAULT_ARGUMENTS} --ui=${K3D_NGUI_BINARY}
		)

	ADD_CUSTOM_TARGET(run-gdb-core
		COMMAND gdb ${K3D_EXTRA_GDB_ARGUMENTS} ${k3d_BINARY_DIR}/bin/k3d core
		)

	ADD_CUSTOM_TARGET(run-valgrind
		COMMAND valgrind -v ${k3d_BINARY_DIR}/bin/k3d ${K3D_DEFAULT_ARGUMENTS} --ui=${K3D_NGUI_BINARY}
		)

	ADD_CUSTOM_TARGET(run-strace
		COMMAND strace ${k3d_BINARY_DIR}/bin/k3d ${K3D_DEFAULT_ARGUMENTS} --ui=${K3D_NGUI_BINARY}
		)
ENDIF(K3D_BUILD_NGUI_MODULE)

IF(K3D_BUILD_PYUI_MODULE)
	ADD_CUSTOM_TARGET(run-pyui
		COMMAND ${k3d_BINARY_DIR}/bin/k3d ${K3D_DEFAULT_ARGUMENTS} --ui=${K3D_PYUI_BINARY}
		)

	ADD_CUSTOM_TARGET(run-gdb-pyui
		COMMAND gdb ${K3D_EXTRA_GDB_ARGUMENTS} --args ${k3d_BINARY_DIR}/bin/k3d ${K3D_DEFAULT_ARGUMENTS} --ui=${K3D_PYUI_BINARY}
		)
ENDIF(K3D_BUILD_PYUI_MODULE)

INSTALL(TARGETS k3d DESTINATION bin)

=== bugs/CMakeLists.txt ===
PROJECT(ditz)

FIND_PROGRAM(DITZ_EXECUTABLE ditz)
MARK_AS_ADVANCED(DITZ_EXECUTABLE)

ADD_CUSTOM_TARGET(bugs-html
	WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}"
	COMMAND ${DITZ_EXECUTABLE} html "${CMAKE_CURRENT_BINARY_DIR}/html"
	)

=== distribution/CMakeLists.txt ===
# Setup automatic generation of the changelog
ADD_CUSTOM_TARGET(changelog
	COMMAND ${HGCOMMAND} log > ${k3d_BINARY_DIR}/ChangeLog
	WORKING_DIRECTORY ${k3d_SOURCE_DIR}
	)

# Setup convenience targets for tagging and branching
SET(K3D_VERSION_TAG "k3d-${K3D_MAJOR_VERSION}.${K3D_MINOR_VERSION}.${K3D_RELEASE_VERSION}.${K3D_BUILD_VERSION}")
ADD_CUSTOM_TARGET(tag-version
	COMMAND ${HGCOMMAND} tag ${K3D_VERSION_TAG}
	WORKING_DIRECTORY ${k3d_SOURCE_DIR}
	)

#SET(K3D_BRANCH_TAG "k3d-release-${K3D_MAJOR_VERSION}.${K3D_MINOR_VERSION}")
#ADD_CUSTOM_TARGET(tag-branch
#	COMMAND ${SVNCOMMAND} cp ${K3D_SVN_TRUNK}
#	${K3D_SVN_BRANCHES}/${K3D_BRANCH_TAG} -m "COMP: Branched K-3D Version ${K3D_MAJOR_VERSION}.${K3D_MINOR_VERSION}"
#	WORKING_DIRECTORY ${k3d_SOURCE_DIR}
#	)

# Get a SourceForge username so we can upload distributables to the FRS
IF(WIN32)
	SET(K3D_SOURCEFORGE_USERNAME "$ENV{USERNAME}" CACHE STRING "SourceForge user account name, for uploading distribution files.")
ELSE(WIN32)
	SET(K3D_SOURCEFORGE_USERNAME "$ENV{USER}" CACHE STRING "SourceForge user account name, for uploading distribution files.")
ENDIF(WIN32)
MARK_AS_ADVANCED(K3D_SOURCEFORGE_USERNAME)

# Setup default packaging parameters (deprecated) ...
SET(CPACK_PACKAGE_DESCRIPTION "K-3D free-as-in-freedom modeling, animation and rendering system")
SET(CPACK_PACKAGE_FILE_NAME "k3d-setup-${K3D_VERSION}")
SET(CPACK_PACKAGE_INSTALL_DIRECTORY "K-3D ${K3D_VERSION}")
SET(CPACK_PACKAGE_INSTALL_REGISTRY_KEY "K-3D ${K3D_VERSION}")
SET(CPACK_PACKAGE_NAME "k3d")
SET(CPACK_PACKAGE_VENDOR "www.k-3d.org")
SET(CPACK_PACKAGE_VERSION ${K3D_VERSION})
SET(CPACK_PACKAGE_VERSION_MAJOR ${K3D_MAJOR_VERSION})
SET(CPACK_PACKAGE_VERSION_MINOR ${K3D_MINOR_VERSION})
SET(CPACK_PACKAGE_VERSION_PATCH ${K3D_RELEASE_VERSION})
SET(CPACK_RESOURCE_FILE_LICENSE "${k3d_SOURCE_DIR}/COPYING")

# Setup global packaging parameters ...
SET(K3D_CPACK_INSTALL_CMAKE_PROJECTS "${k3d_BINARY_DIR};k3d;ALL;/")
SET(K3D_CPACK_PACKAGE_DESCRIPTION "K-3D free-as-in-freedom modeling, animation, and rendering system.")
SET(K3D_CPACK_PACKAGE_FILE_NAME "k3d-setup-${K3D_VERSION}")
SET(K3D_CPACK_PACKAGE_NAME "k3d")
SET(K3D_CPACK_PACKAGE_VERSION "${K3D_VERSION}")
SET(K3D_CPACK_RESOURCE_FILE_LICENSE "${k3d_SOURCE_DIR}/COPYING")
SET(K3D_CPACK_SOURCE_IGNORE_FILES "/CVS/;/.svn/;/.hg/")
SET(K3D_CPACK_SOURCE_INSTALLED_DIRECTORIES "${k3d_SOURCE_DIR};/")
SET(K3D_CPACK_SOURCE_PACKAGE_FILE_NAME "k3d-source-${K3D_VERSION}")

# Setup some macros that can be used by the platform-specific distribution logic
MACRO(K3D_CHECK_INSTALLED_VERSION FOUND PACKAGE EXPECTED)
	IF(NOT ${FOUND} STREQUAL ${EXPECTED})
		MESSAGE(SEND_ERROR "Found ${PACKAGE} version ${FOUND} - for installation, version ${EXPECTED} is required.")
	ENDIF(NOT ${FOUND} STREQUAL ${EXPECTED})
ENDMACRO(K3D_CHECK_INSTALLED_VERSION)

MACRO(K3D_CHECK_INSTALLED_PYTHON_DEPENDENCY CONFIG)
	IF(${CONFIG} AND NOT K3D_INSTALL_PYTHON)
		MESSAGE(SEND_ERROR "K3D_INSTALL_PYTHON is required by ${CONFIG}.")
	ENDIF(${CONFIG} AND NOT K3D_INSTALL_PYTHON)
ENDMACRO(K3D_CHECK_INSTALLED_PYTHON_DEPENDENCY)

# Generate source packages
ADD_SUBDIRECTORY(source)

# Generate platform-specific binary packages
IF(APPLE)
	ADD_SUBDIRECTORY(osx)
ENDIF(APPLE)

IF(UNIX AND NOT APPLE)
	ADD_SUBDIRECTORY(posix)
ENDIF(UNIX AND NOT APPLE)

IF(WIN32)
	ADD_SUBDIRECTORY(win32)
ENDIF(WIN32)

=== k3dsdk/CMakeLists.txt ===
PROJECT(k3dsdk)

FILE(GLOB HEADERS *.h)
FILE(GLOB SOURCES *.cpp)

LIST(SORT HEADERS)
LIST(SORT SOURCES)

IF(WIN32 AND K3D_COMPILER_GCC)
	# For some reason, serialization_xml.cpp takes *forever* to build with optimizations enabled
	SET_SOURCE_FILES_PROPERTIES(serialization_xml.cpp PROPERTIES COMPILE_FLAGS -O0)
ENDIF(WIN32 AND K3D_COMPILER_GCC)

CONFIGURE_FILE(${k3dsdk_SOURCE_DIR}/k3d-i18n-config.h.in ${k3dsdk_BINARY_DIR}/k3d-i18n-config.h)
CONFIGURE_FILE(${k3dsdk_SOURCE_DIR}/k3d-parallel-config.h.in ${k3dsdk_BINARY_DIR}/k3d-parallel-config.h)
CONFIGURE_FILE(${k3dsdk_SOURCE_DIR}/k3d-path-config.h.in ${k3dsdk_BINARY_DIR}/k3d-path-config.h)
CONFIGURE_FILE(${k3dsdk_SOURCE_DIR}/k3d-platform-config.h.in ${k3dsdk_BINARY_DIR}/k3d-platform-config.h)
CONFIGURE_FILE(${k3dsdk_SOURCE_DIR}/k3d-version-config.h.in ${k3dsdk_BINARY_DIR}/k3d-version-config.h)

INCLUDE_DIRECTORIES(${k3d_SOURCE_DIR})
INCLUDE_DIRECTORIES(${k3dsdk_SOURCE_DIR}/gil)
INCLUDE_DIRECTORIES(${k3dsdk_BINARY_DIR})
INCLUDE_DIRECTORIES(${K3D_BOOST_INCLUDE_DIRS})
INCLUDE_DIRECTORIES(${K3D_GLIBMM_INCLUDE_DIRS})
INCLUDE_DIRECTORIES(${K3D_SIGC_INCLUDE_DIRS})
INCLUDE_DIRECTORIES(${K3D_OPENGL_INCLUDE_DIR})

IF(K3D_ENABLE_PARALLEL)
	INCLUDE_DIRECTORIES(${K3D_TBB_INCLUDE_DIR})
ENDIF(K3D_ENABLE_PARALLEL)

IF(K3D_ENABLE_PROFILING)
    INCLUDE_DIRECTORIES(${K3D_GOOGLE_PERFTOOLS_INCLUDE_DIR})
ENDIF(K3D_ENABLE_PROFILING)

IF(NOT WIN32)
	INCLUDE_DIRECTORIES(${K3D_UUID_INCLUDE_DIRS})
ENDIF(NOT WIN32)

INCLUDE_DIRECTORIES(${K3D_XML_INCLUDE_DIR})
INCLUDE_DIRECTORIES(${K3D_ZLIB_INCLUDE_DIRS})

LINK_DIRECTORIES(${K3D_BOOST_LIB_DIRS})
LINK_DIRECTORIES(${K3D_GLIBMM_LIB_DIRS})
LINK_DIRECTORIES(${K3D_SIGC_LIB_DIRS})
LINK_DIRECTORIES(${K3D_ZLIB_LIB_DIRS})

IF(NOT WIN32)
	LINK_DIRECTORIES(${K3D_UUID_LIB_DIRS})
ENDIF(NOT WIN32)

K3D_ADD_LIBRARY(k3dsdk SHARED ${HEADERS} ${SOURCES})
K3D_GENERATE_DEF_FILE(k3dsdk)

TARGET_LINK_LIBRARIES(k3dsdk
	${K3D_GLIBMM_LIBS}
	${K3D_SIGC_LIBS}
	${K3D_XML_LIB}
	${K3D_ZLIB_LIBS}
	${K3D_OPENGL_GL_LIBRARY}
	${K3D_OPENGL_GLU_LIBRARY}
	k3dsdk-half
	k3dsdk-sgi-tesselator
	k3dsdk-glew
	k3dsdk-parallel
	${K3D_BOOST_UNIT_TEST_FRAMEWORK_LIBS}
	)

IF(NOT WIN32)
	TARGET_LINK_LIBRARIES(k3dsdk ${K3D_UUID_LIBS})
ENDIF(NOT WIN32)

IF(K3D_ENABLE_NLS)
	INCLUDE_DIRECTORIES(${K3D_INTL_INCLUDE_DIRS})
	TARGET_LINK_LIBRARIES(k3dsdk ${K3D_INTL_LIBS})
ENDIF(K3D_ENABLE_NLS)

IF(K3D_ENABLE_PROFILING)
    TARGET_LINK_LIBRARIES(k3dsdk ${K3D_PROFILER_LIBRARY})
ENDIF(K3D_ENABLE_PROFILING)

IF(WIN32)
	TARGET_LINK_LIBRARIES(k3dsdk ole32)
	TARGET_LINK_LIBRARIES(k3dsdk ws2_32)
ENDIF(WIN32)

ADD_SUBDIRECTORY(Half)
ADD_SUBDIRECTORY(expression)
ADD_SUBDIRECTORY(ftgl)
ADD_SUBDIRECTORY(glew)
ADD_SUBDIRECTORY(parallel)
ADD_SUBDIRECTORY(resource)
ADD_SUBDIRECTORY(sgi_tesselator)
ADD_SUBDIRECTORY(subdivision_surface)

K3D_CONDITIONAL_BUILD(K3D_BUILD_NGUI_MODULE ngui)
K3D_CONDITIONAL_BUILD(K3D_ENABLE_PYTHON python)

INSTALL(TARGETS k3dsdk
	RUNTIME DESTINATION bin
	LIBRARY DESTINATION ${K3D_LIBDIR}
	ARCHIVE DESTINATION ${K3D_LIBDIR})
INSTALL(FILES ${HEADERS} DESTINATION include/k3d/k3dsdk)

INSTALL(FILES ${k3dsdk_BINARY_DIR}/k3d-i18n-config.h DESTINATION ${K3D_LIBDIR}/k3d/include)
INSTALL(FILES ${k3dsdk_BINARY_DIR}/k3d-parallel-config.h DESTINATION ${K3D_LIBDIR}/k3d/include)
INSTALL(FILES ${k3dsdk_BINARY_DIR}/k3d-path-config.h DESTINATION ${K3D_LIBDIR}/k3d/include)
INSTALL(FILES ${k3dsdk_BINARY_DIR}/k3d-platform-config.h DESTINATION ${K3D_LIBDIR}/k3d/include)
INSTALL(FILES ${k3dsdk_BINARY_DIR}/k3d-version-config.h DESTINATION ${K3D_LIBDIR}/k3d/include)

=== make-module-proxy/CMakeLists.txt ===
PROJECT(k3d-make-module-proxy)

INCLUDE_DIRECTORIES(${k3d_SOURCE_DIR})
INCLUDE_DIRECTORIES(${k3dsdk_BINARY_DIR})
INCLUDE_DIRECTORIES(${K3D_BOOST_INCLUDE_DIRS})
INCLUDE_DIRECTORIES(${K3D_GLIBMM_INCLUDE_DIRS})
INCLUDE_DIRECTORIES(${K3D_SIGC_INCLUDE_DIRS})

LINK_DIRECTORIES(${K3D_BOOST_LIB_DIRS})
LINK_DIRECTORIES(${K3D_GLIBMM_LIB_DIRS})
LINK_DIRECTORIES(${K3D_SIGC_LIB_DIRS})

ADD_EXECUTABLE(k3d-make-module-proxy main.cpp)
TARGET_LINK_LIBRARIES(k3d-make-module-proxy k3dsdk)

=== man/CMakeLists.txt ===
CONFIGURE_FILE(k3d.1.in k3d.1)
CONFIGURE_FILE(k3d-renderframe.1.in k3d-renderframe.1)
CONFIGURE_FILE(k3d-renderjob.1.in k3d-renderjob.1)
CONFIGURE_FILE(k3d-sl2xml.1.in k3d-sl2xml.1)
CONFIGURE_FILE(k3d-uuidgen.1.in k3d-uuidgen.1)

INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/k3d.1 DESTINATION share/man/man1)
INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/k3d-renderframe.1 DESTINATION share/man/man1)
INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/k3d-renderjob.1 DESTINATION share/man/man1)
INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/k3d-sl2xml.1 DESTINATION share/man/man1)
INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/k3d-uuidgen.1 DESTINATION share/man/man1)

=== modules/CMakeLists.txt ===
SET(K3D_PLUGINS "")

INCLUDE(K3DParseArguments)

MACRO(K3D_BUILD_MODULE MODULE_NAME)
	K3D_PARSE_ARGUMENTS(MODULE "EXTRA_SOURCES;EXCLUDE_SOURCES" "" ${ARGN})

	SET(K3D_PLUGINS ${K3D_PLUGINS} ${MODULE_NAME} PARENT_SCOPE)

	FILE(GLOB ABSOLUTE_HEADERS *.h)
	FILE(GLOB ABSOLUTE_SOURCES *.cpp)

	LIST(SORT ABSOLUTE_HEADERS)
	LIST(SORT ABSOLUTE_SOURCES)

	FOREACH(ABSOLUTE_HEADER ${ABSOLUTE_HEADERS})
		GET_FILENAME_COMPONENT(HEADER ${ABSOLUTE_HEADER} NAME)
		LIST(APPEND HEADERS ${HEADER})
	ENDFOREACH()

	FOREACH(ABSOLUTE_SOURCE ${ABSOLUTE_SOURCES})
		GET_FILENAME_COMPONENT(SOURCE ${ABSOLUTE_SOURCE} NAME)
		LIST(APPEND SOURCES ${SOURCE})
	ENDFOREACH()

	LIST(LENGTH HEADERS HEADER_COUNT)
	LIST(LENGTH SOURCES SOURCE_COUNT)

	IF(HEADER_COUNT GREATER 0)
		FOREACH(MODULE_EXCLUDE_SOURCE ${MODULE_EXCLUDE_SOURCES})
			LIST(REMOVE_ITEM HEADERS ${MODULE_EXCLUDE_SOURCE})
		ENDFOREACH()
	ENDIF()

	IF(SOURCE_COUNT GREATER 0)
		FOREACH(MODULE_EXCLUDE_SOURCE ${MODULE_EXCLUDE_SOURCES})
			LIST(REMOVE_ITEM SOURCES ${MODULE_EXCLUDE_SOURCE})
		ENDFOREACH()
	ENDIF()

	INCLUDE_DIRECTORIES(${k3d_SOURCE_DIR})
	INCLUDE_DIRECTORIES(${k3dsdk_SOURCE_DIR}/gil)
	INCLUDE_DIRECTORIES(${k3dsdk_BINARY_DIR})
	INCLUDE_DIRECTORIES(${K3D_BOOST_INCLUDE_DIRS})
	INCLUDE_DIRECTORIES(${K3D_GLIBMM_INCLUDE_DIRS})
	INCLUDE_DIRECTORIES(${K3D_SIGC_INCLUDE_DIRS})
	INCLUDE_DIRECTORIES(${K3D_OPENGL_INCLUDE_DIR})

	IF(K3D_ENABLE_NLS)
		INCLUDE_DIRECTORIES(${K3D_INTL_INCLUDE_DIRS})
	ENDIF(K3D_ENABLE_NLS)

	IF(K3D_ENABLE_PARALLEL)
		INCLUDE_DIRECTORIES(${K3D_TBB_INCLUDE_DIR})
	ENDIF(K3D_ENABLE_PARALLEL)
	
	IF(K3D_ENABLE_PROFILING)
        INCLUDE_DIRECTORIES(${K3D_GOOGLE_PERFTOOLS_INCLUDE_DIR})
    ENDIF(K3D_ENABLE_PROFILING)

	LINK_DIRECTORIES(${K3D_BOOST_LIB_DIRS})
	LINK_DIRECTORIES(${K3D_SIGC_LIB_DIRS})

	ADD_LIBRARY(${MODULE_NAME} MODULE ${HEADERS} ${SOURCES} ${MODULE_EXTRA_SOURCES})
	SET_TARGET_PROPERTIES(${MODULE_NAME} PROPERTIES
		LIBRARY_OUTPUT_DIRECTORY ${k3d_BINARY_DIR}/${K3D_LIBDIR}/k3d/plugins
		PREFIX ""
		SUFFIX ".module"
		)

	TARGET_LINK_LIBRARIES(${MODULE_NAME} k3dsdk)

	IF(K3D_ENABLE_NLS)
		TARGET_LINK_LIBRARIES(${MODULE_NAME} ${K3D_INTL_LIBS})
	ENDIF(K3D_ENABLE_NLS)
	
	IF(K3D_ENABLE_PROFILING)
        TARGET_LINK_LIBRARIES(${PLUGIN_NAME} ${K3D_PROFILER_LIBRARY})
    ENDIF(K3D_ENABLE_PROFILING)

	INSTALL(TARGETS ${MODULE_NAME}
		RUNTIME DESTINATION ${K3D_LIBDIR}/k3d/plugins
		LIBRARY DESTINATION ${K3D_LIBDIR}/k3d/plugins)
ENDMACRO(K3D_BUILD_MODULE)

MACRO(K3D_BUILD_NGUI_MODULE MODULE_NAME)
	INCLUDE_DIRECTORIES(${K3D_CAIROMM_INCLUDE_DIRS})
	INCLUDE_DIRECTORIES(${K3D_GTKMM_INCLUDE_DIRS})
	INCLUDE_DIRECTORIES(${K3D_GTKGLEXT_INCLUDE_DIRS})

	LINK_DIRECTORIES(${K3D_GTKGLEXT_LIB_DIRS})

	K3D_BUILD_MODULE(${MODULE_NAME} ${ARGN})

	TARGET_LINK_LIBRARIES(${MODULE_NAME} k3dsdk-ngui)
	TARGET_LINK_LIBRARIES(${MODULE_NAME} ${K3D_CAIROMM_LIBS})
ENDMACRO(K3D_BUILD_NGUI_MODULE)

MACRO(K3D_CREATE_MODULE_PROXY MODULE_NAME)
	GET_TARGET_PROPERTY(K3D_MAKE_MODULE_PROXY k3d-make-module-proxy LOCATION)
	GET_TARGET_PROPERTY(MODULE ${MODULE_NAME} LOCATION)
	ADD_CUSTOM_COMMAND(
		OUTPUT ${MODULE}.proxy
		COMMAND ${K3D_MAKE_MODULE_PROXY} ${MODULE} ${MODULE}.proxy
		DEPENDS k3d-make-module-proxy ${MODULE_NAME}
		)
	ADD_CUSTOM_TARGET(${MODULE_NAME}-proxy ALL DEPENDS ${MODULE}.proxy)
	INSTALL(FILES ${MODULE}.proxy DESTINATION ${K3D_LIBDIR}/k3d/plugins)
ENDMACRO(K3D_CREATE_MODULE_PROXY)

K3D_CONDITIONAL_BUILD(K3D_BUILD_3DS_IO_MODULE 3ds_io)
K3D_CONDITIONAL_BUILD(K3D_BUILD_ADVANCED_OPENGL_PAINTERS_MODULE advanced_opengl_painters)
K3D_CONDITIONAL_BUILD(K3D_BUILD_ANIMATION_MODULE animation)
K3D_CONDITIONAL_BUILD(K3D_BUILD_ANNOTATION_MODULE annotation)
K3D_CONDITIONAL_BUILD(K3D_BUILD_ARRAY_MODULE array)
K3D_CONDITIONAL_BUILD(K3D_BUILD_BICUBIC_PATCH_MODULE bicubic_patch)
K3D_CONDITIONAL_BUILD(K3D_BUILD_BILINEAR_PATCH_MODULE bilinear_patch)
K3D_CONDITIONAL_BUILD(K3D_BUILD_BITMAP_MODULE bitmap)
K3D_CONDITIONAL_BUILD(K3D_BUILD_BLOBBY_MODULE blobby)
K3D_CONDITIONAL_BUILD(K3D_BUILD_BUNDLED_RENDERMAN_ENGINES_MODULE bundled_renderman_engines)
K3D_CONDITIONAL_BUILD(K3D_BUILD_CARVE_MODULE carve)
K3D_CONDITIONAL_BUILD(K3D_BUILD_CGAL_MODULE cgal)
K3D_CONDITIONAL_BUILD(K3D_BUILD_CLOTH_MODULE cloth)
K3D_CONDITIONAL_BUILD(K3D_BUILD_COLLADA_IO_MODULE collada_io)
K3D_CONDITIONAL_BUILD(K3D_BUILD_COMPIZ_MODULE compiz)
K3D_CONDITIONAL_BUILD(K3D_BUILD_CORE_MODULE core)
K3D_CONDITIONAL_BUILD(K3D_BUILD_CUDA_MODULE cuda)
K3D_CONDITIONAL_BUILD(K3D_BUILD_DEFORMATION_MODULE deformation)
K3D_CONDITIONAL_BUILD(K3D_BUILD_DEVELOPMENT_MODULE development)
K3D_CONDITIONAL_BUILD(K3D_BUILD_DOUBLE_MODULE double)
K3D_CONDITIONAL_BUILD(K3D_BUILD_EULER_OPERATIONS_MODULE euler_operations)
K3D_CONDITIONAL_BUILD(K3D_BUILD_FILE_MAGIC_MODULE file_magic)
K3D_CONDITIONAL_BUILD(K3D_BUILD_FREETYPE2_MODULE freetype2)
K3D_CONDITIONAL_BUILD(K3D_BUILD_GLX_MODULE glx)
K3D_CONDITIONAL_BUILD(K3D_BUILD_GNOME_MODULE gnome)
K3D_CONDITIONAL_BUILD(K3D_BUILD_GOOGLE_PERFTOOLS_MODULE google_perftools)
K3D_CONDITIONAL_BUILD(K3D_BUILD_GRAPHVIZ_MODULE graphviz)
K3D_CONDITIONAL_BUILD(K3D_BUILD_GTS_IO_MODULE gts_io)
K3D_CONDITIONAL_BUILD(K3D_BUILD_GTS_MODULE gts)
K3D_CONDITIONAL_BUILD(K3D_BUILD_HIGHLIGHTING_MODULE highlighting)
K3D_CONDITIONAL_BUILD(K3D_BUILD_IMAGEMAGICK_IO_MODULE imagemagick_io)
K3D_CONDITIONAL_BUILD(K3D_BUILD_INDIGO_MODULE indigo)
K3D_CONDITIONAL_BUILD(K3D_BUILD_INOTIFY_MODULE inotify)
K3D_CONDITIONAL_BUILD(K3D_BUILD_JPEG_IO_MODULE jpeg_io)
K3D_CONDITIONAL_BUILD(K3D_BUILD_K3D_IO_MODULE k3d_io)
K3D_CONDITIONAL_BUILD(K3D_BUILD_LINEAR_CURVE_MODULE linear_curve)
K3D_CONDITIONAL_BUILD(K3D_BUILD_LIPSYNC_MODULE lipsync)
K3D_CONDITIONAL_BUILD(K3D_BUILD_LSYSTEM_MODULE lsystem)
K3D_CONDITIONAL_BUILD(K3D_BUILD_LUXRENDER_MODULE luxrender)
K3D_CONDITIONAL_BUILD(K3D_BUILD_MATRIX_MODULE matrix)
K3D_CONDITIONAL_BUILD(K3D_BUILD_MD2_IO_MODULE md2_io)
K3D_CONDITIONAL_BUILD(K3D_BUILD_MESH_ATTRIBUTES_MODULE mesh_attributes)
K3D_CONDITIONAL_BUILD(K3D_BUILD_MESH_INSTANCE_MODULE mesh_instance)
K3D_CONDITIONAL_BUILD(K3D_BUILD_MESH_MODULE mesh)
K3D_CONDITIONAL_BUILD(K3D_BUILD_NGUI_ABOUT_MODULE ngui_about)
K3D_CONDITIONAL_BUILD(K3D_BUILD_NGUI_ANIMATION_TIMELINE_PANEL_MODULE ngui_animation_timeline_panel)
K3D_CONDITIONAL_BUILD(K3D_BUILD_NGUI_ASSIGN_HOTKEYS_MODULE ngui_assign_hotkeys)
K3D_CONDITIONAL_BUILD(K3D_BUILD_NGUI_ATK_EVENT_RECORDER_MODULE ngui_atk_event_recorder)
K3D_CONDITIONAL_BUILD(K3D_BUILD_NGUI_KNOT_VECTOR_CONTROL_MODULE ngui_knot_vector_control)
K3D_CONDITIONAL_BUILD(K3D_BUILD_NGUI_LEARNING_MODULE ngui_learning)
K3D_CONDITIONAL_BUILD(K3D_BUILD_NGUI_LOG_MODULE ngui_log)
K3D_CONDITIONAL_BUILD(K3D_BUILD_NGUI_MATERIAL_MANAGER_PANEL_MODULE ngui_material_manager_panel)
K3D_CONDITIONAL_BUILD(K3D_BUILD_NGUI_MESH_CONTROL_MODULE ngui_mesh_control)
K3D_CONDITIONAL_BUILD(K3D_BUILD_NGUI_MODULE ngui)
K3D_CONDITIONAL_BUILD(K3D_BUILD_NGUI_MORPH_POINTS_PAGE_MODULE ngui_morph_points_page)
K3D_CONDITIONAL_BUILD(K3D_BUILD_NGUI_NODE_HISTORY_PANEL_MODULE ngui_node_history_panel)
K3D_CONDITIONAL_BUILD(K3D_BUILD_NGUI_NODE_LIST_PANEL_MODULE ngui_node_list_panel)
K3D_CONDITIONAL_BUILD(K3D_BUILD_NGUI_NODE_PROPERTIES_PANEL_MODULE ngui_node_properties_panel)
K3D_CONDITIONAL_BUILD(K3D_BUILD_NGUI_OPENGL_DIALOG_MODULE ngui_opengl_dialog)
K3D_CONDITIONAL_BUILD(K3D_BUILD_NGUI_PARENT_TOOL_MODULE ngui_parent_tool)
K3D_CONDITIONAL_BUILD(K3D_BUILD_NGUI_PIPELINE_PANEL_MODULE ngui_pipeline_panel)
K3D_CONDITIONAL_BUILD(K3D_BUILD_NGUI_PIPELINE_PROFILER_PANEL_MODULE ngui_pipeline_profiler_panel)
K3D_CONDITIONAL_BUILD(K3D_BUILD_NGUI_PYTHON_SHELL_MODULE ngui_python_shell)
K3D_CONDITIONAL_BUILD(K3D_BUILD_NGUI_RECTANGLE_CONTROL_MODULE ngui_rectangle_control)
K3D_CONDITIONAL_BUILD(K3D_BUILD_NGUI_RENDER_REGION_TOOL_MODULE ngui_render_region_tool)
K3D_CONDITIONAL_BUILD(K3D_BUILD_NGUI_SELECTION_CONTROL_MODULE ngui_selection_control)
K3D_CONDITIONAL_BUILD(K3D_BUILD_NGUI_SNAP_TOOL_MODULE ngui_snap_tool)
K3D_CONDITIONAL_BUILD(K3D_BUILD_NGUI_SPACE_NAVIGATOR_MODULE ngui_space_navigator)
K3D_CONDITIONAL_BUILD(K3D_BUILD_NGUI_TEXT_EDITOR_MODULE ngui_text_editor)
K3D_CONDITIONAL_BUILD(K3D_BUILD_NGUI_TIMELINE_PANEL_MODULE ngui_timeline_panel)
K3D_CONDITIONAL_BUILD(K3D_BUILD_NGUI_TOOLBAR_PANEL_MODULE ngui_toolbar_panel)
K3D_CONDITIONAL_BUILD(K3D_BUILD_NGUI_TOOL_PROPERTIES_PANEL_MODULE ngui_tool_properties_panel)
K3D_CONDITIONAL_BUILD(K3D_BUILD_NGUI_UNDO_TREE_PANEL_MODULE ngui_undo_tree_panel)
K3D_CONDITIONAL_BUILD(K3D_BUILD_NGUI_UV_EDITOR_PANEL_MODULE ngui_uv_editor_panel)
K3D_CONDITIONAL_BUILD(K3D_BUILD_NUI_MODULE nui)
K3D_CONDITIONAL_BUILD(K3D_BUILD_NURBS_MODULE nurbs)
K3D_CONDITIONAL_BUILD(K3D_BUILD_NURBS_SOURCES_MODULE nurbs_sources)
K3D_CONDITIONAL_BUILD(K3D_BUILD_OBJ_IO_MODULE obj_io)
K3D_CONDITIONAL_BUILD(K3D_BUILD_ODE_MODULE ode)
K3D_CONDITIONAL_BUILD(K3D_BUILD_OGRE_IO_MODULE ogre_io)
K3D_CONDITIONAL_BUILD(K3D_BUILD_OPENCASCADE_MODULE opencascade)
K3D_CONDITIONAL_BUILD(K3D_BUILD_OPENEXR_IO_MODULE openexr_io)
K3D_CONDITIONAL_BUILD(K3D_BUILD_OPENGL_MODULE opengl)
K3D_CONDITIONAL_BUILD(K3D_BUILD_OSX_MODULE osx)
K3D_CONDITIONAL_BUILD(K3D_BUILD_PARTICLE_MODULE particle)
K3D_CONDITIONAL_BUILD(K3D_BUILD_PDIFF_MODULE pdiff)
K3D_CONDITIONAL_BUILD(K3D_BUILD_PIXIE_MODULE pixie)
K3D_CONDITIONAL_BUILD(K3D_BUILD_PLOT_MODULE plot)
K3D_CONDITIONAL_BUILD(K3D_BUILD_PLY_IO_MODULE ply_io)
K3D_CONDITIONAL_BUILD(K3D_BUILD_PNG_IO_MODULE png_io)
K3D_CONDITIONAL_BUILD(K3D_BUILD_POLYHEDRON_MODULE polyhedron)
K3D_CONDITIONAL_BUILD(K3D_BUILD_POLYHEDRON_SOURCES_MODULE polyhedron_sources)
K3D_CONDITIONAL_BUILD(K3D_BUILD_PYTHON_MODULE python)
K3D_CONDITIONAL_BUILD(K3D_BUILD_PYUI_MODULE pyui)
K3D_CONDITIONAL_BUILD(K3D_BUILD_QSLIM_MODULE qslim)
K3D_CONDITIONAL_BUILD(K3D_BUILD_QUADRICS_MODULE quadrics)
K3D_CONDITIONAL_BUILD(K3D_BUILD_REFERENCE_OPENGL_PAINTERS_MODULE reference_opengl_painters)
K3D_CONDITIONAL_BUILD(K3D_BUILD_RENDERMAN_ENGINES_MODULE renderman_engines)
K3D_CONDITIONAL_BUILD(K3D_BUILD_RENDERMAN_MODULE renderman)
K3D_CONDITIONAL_BUILD(K3D_BUILD_RENDERMAN_PAINTERS_MODULE renderman_painters)
K3D_CONDITIONAL_BUILD(K3D_BUILD_RELEASE_MODULE release)
K3D_CONDITIONAL_BUILD(K3D_BUILD_SCRIPTED_PLUGINS_MODULE scripted_plugins)
K3D_CONDITIONAL_BUILD(K3D_BUILD_SCRIPTING_MODULE scripting)
K3D_CONDITIONAL_BUILD(K3D_BUILD_SELECTION_MODULE selection)
K3D_CONDITIONAL_BUILD(K3D_BUILD_SOLAR_MODULE solar)
K3D_CONDITIONAL_BUILD(K3D_BUILD_STL_IO_MODULE stl_io)
K3D_CONDITIONAL_BUILD(K3D_BUILD_SUBDIVISION_SURFACE_MODULE subdivision_surface)
K3D_CONDITIONAL_BUILD(K3D_BUILD_SVG_IO_MODULE svg_io)
K3D_CONDITIONAL_BUILD(K3D_BUILD_TEST_MODULE test)
K3D_CONDITIONAL_BUILD(K3D_BUILD_TIFF_IO_MODULE tiff_io)
K3D_CONDITIONAL_BUILD(K3D_BUILD_TIME_MODULE time)
K3D_CONDITIONAL_BUILD(K3D_BUILD_UNIFORM_POLYHEDRON_MODULE uniform_polyhedron)
K3D_CONDITIONAL_BUILD(K3D_BUILD_VIRTUAL_OFFSCREEN_MODULE virtual_offscreen)
K3D_CONDITIONAL_BUILD(K3D_BUILD_VIRTUAL_OPENGL_PAINTERS_MODULE virtual_opengl_painters)
K3D_CONDITIONAL_BUILD(K3D_BUILD_WGL_MODULE wgl)
K3D_CONDITIONAL_BUILD(K3D_BUILD_WINDOWS_MODULE windows)
K3D_CONDITIONAL_BUILD(K3D_BUILD_XTRACKCAD_MODULE xtrackcad)
K3D_CONDITIONAL_BUILD(K3D_BUILD_YAFRAY_MODULE yafray)

ADD_SUBDIRECTORY(external)

# Test for unwanted plugin binaries ...
FILE(GLOB_RECURSE PLUGIN_BINARIES "${k3d_BINARY_DIR}/${K3D_LIBDIR}/k3d/plugins/*")
LIST(SORT PLUGIN_BINARIES)
FOREACH(PLUGIN_BINARY ${PLUGIN_BINARIES})
	GET_FILENAME_COMPONENT(RELATIVE_PLUGIN_BINARY ${PLUGIN_BINARY} NAME)

	SET(UNEXPECTED_FILE 1)
	FOREACH(K3D_PLUGIN ${K3D_PLUGINS})
		IF(RELATIVE_PLUGIN_BINARY MATCHES "${K3D_PLUGIN}.module")
			SET(UNEXPECTED_FILE 0)
			BREAK()
		ELIF(RELATIVE_PLUGIN_BINARY MATCHES "${K3D_PLUGIN}.module.proxy")
			SET(UNEXPECTED_FILE 0)
			BREAK()
		ENDIF()
	ENDFOREACH()

	IF(UNEXPECTED_FILE)
		MESSAGE(SEND_ERROR "Unexpected file in plugin directory ... delete ${PLUGIN_BINARY} to eliminate this error.")
	ENDIF()
ENDFOREACH()

=== po/CMakeLists.txt ===
PROJECT(po)

FIND_PROGRAM(K3D_INTLTOOL_UPDATE intltool-update)
MARK_AS_ADVANCED(K3D_INTLTOOL_UPDATE)

FIND_PROGRAM(K3D_XGETTEXT xgettext)
MARK_AS_ADVANCED(K3D_XGETTEXT)

FIND_PROGRAM(K3D_MSGMERGE msgmerge)
MARK_AS_ADVANCED(K3D_MSGMERGE)

FIND_PROGRAM(K3D_MSGFMT msgfmt)
MARK_AS_ADVANCED(K3D_MSGFMT)

MESSAGE(STATUS "generating i18n catalog")

SET(SKIP_FILES
	"^share/shaders/"
	)

SET(LOCALIZABLE_FILES "")
FILE(GLOB_RECURSE TEMP_FILES "${k3d_SOURCE_DIR}/*.h")
LIST(APPEND LOCALIZABLE_FILES ${TEMP_FILES})
FILE(GLOB_RECURSE TEMP_FILES "${k3d_SOURCE_DIR}/*.cpp")
LIST(APPEND LOCALIZABLE_FILES ${TEMP_FILES})
LIST(SORT LOCALIZABLE_FILES)

FILE(WRITE ${CMAKE_CURRENT_BINARY_DIR}/POTFILES.in "")
FOREACH(LOCALIZABLE_FILE ${LOCALIZABLE_FILES})
	FILE(RELATIVE_PATH RELATIVE_LOCALIZABLE_FILE ${k3d_SOURCE_DIR} ${LOCALIZABLE_FILE})

	SET(TEST_FILE 1)
	FOREACH(SKIP_FILE ${SKIP_FILES})
		IF(RELATIVE_LOCALIZABLE_FILE MATCHES "${SKIP_FILE}")
			SET(TEST_FILE 0)
			BREAK()
		ENDIF()
	ENDFOREACH()

	IF(TEST_FILE)
		FILE(APPEND ${CMAKE_CURRENT_BINARY_DIR}/POTFILES.in "${RELATIVE_LOCALIZABLE_FILE}\n")
	ENDIF()
ENDFOREACH()

MESSAGE(STATUS "  done")

ADD_CUSTOM_COMMAND(
	DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/POTFILES.in
	COMMAND ${K3D_XGETTEXT} --files-from ${CMAKE_CURRENT_BINARY_DIR}/POTFILES.in --keyword=_ -o ${CMAKE_CURRENT_BINARY_DIR}/k3d.pot --copyright-holder="Timothy M. Shead" --msgid-bugs-address="k3d-development@lists.sourceforge.net" --no-wrap --no-location
	WORKING_DIRECTORY ${k3d_SOURCE_DIR}
	OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/k3d.pot
	)

SET(K3D_CATALOGS chef)
SET(K3D_CATALOG_TARGETS "")
FOREACH(catalog ${K3D_CATALOGS})
	ADD_CUSTOM_TARGET(nls-update-${catalog}.po
		DEPENDS ${po_SOURCE_DIR}/${catalog}.po
		COMMAND ${K3D_MSGMERGE} ${po_SOURCE_DIR}/${catalog}.po ${CMAKE_CURRENT_BINARY_DIR}/k3d.pot -o ${catalog}.po --no-wrap --sort-output
		WORKING_DIRECTORY ${po_SOURCE_DIR}
		)

	FILE(MAKE_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/${catalog}/LC_MESSAGES")

	ADD_CUSTOM_COMMAND(
		DEPENDS ${po_SOURCE_DIR}/${catalog}.po
		COMMAND ${K3D_MSGFMT} -c -o ${CMAKE_CURRENT_BINARY_DIR}/${catalog}/LC_MESSAGES/k3d.mo ${po_SOURCE_DIR}/${catalog}.po
		OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/${catalog}/LC_MESSAGES/k3d.mo
		)

	INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/${catalog}/LC_MESSAGES/k3d.mo
		DESTINATION share/k3d/locale/${catalog}/LC_MESSAGES
		)

	LIST(APPEND K3D_CATALOG_TARGETS ${CMAKE_CURRENT_BINARY_DIR}/${catalog}/LC_MESSAGES/k3d.mo)
ENDFOREACH(catalog)

ADD_CUSTOM_TARGET(nls ALL
	DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/k3d.pot ${K3D_CATALOG_TARGETS}
	)

=== renderframe/CMakeLists.txt ===
PROJECT(renderframe)

INCLUDE_DIRECTORIES(${k3d_SOURCE_DIR})
INCLUDE_DIRECTORIES(${k3dsdk_BINARY_DIR})
INCLUDE_DIRECTORIES(${K3D_BOOST_INCLUDE_DIRS})
INCLUDE_DIRECTORIES(${K3D_GLIBMM_INCLUDE_DIRS})
INCLUDE_DIRECTORIES(${K3D_SIGC_INCLUDE_DIRS})

LINK_DIRECTORIES(${K3D_BOOST_LIB_DIRS})
LINK_DIRECTORIES(${K3D_GLIBMM_LIB_DIRS})
LINK_DIRECTORIES(${K3D_SIGC_LIB_DIRS})

IF(WIN32 AND K3D_COMPILER_GCC)
	# For some reason, building with optimizations enabled causes link problems with boost::regex and auto-import
	SET_SOURCE_FILES_PROPERTIES(main.cpp PROPERTIES COMPILE_FLAGS -O0)
ENDIF(WIN32 AND K3D_COMPILER_GCC)

ADD_EXECUTABLE(k3d-renderframe main.cpp)
TARGET_LINK_LIBRARIES(k3d-renderframe k3dsdk)
TARGET_LINK_LIBRARIES(k3d-renderframe ${K3D_BOOST_REGEX_LIBS})
IF(WIN32 AND K3D_COMPILER_GCC)
	SET_TARGET_PROPERTIES(k3d-renderframe PROPERTIES LINK_FLAGS -mwindows)
ENDIF(WIN32 AND K3D_COMPILER_GCC)

INSTALL(TARGETS k3d-renderframe DESTINATION bin)

=== renderjob/CMakeLists.txt ===
PROJECT(renderjob)

INCLUDE_DIRECTORIES(${k3d_SOURCE_DIR})
INCLUDE_DIRECTORIES(${k3dsdk_BINARY_DIR})
INCLUDE_DIRECTORIES(${K3D_BOOST_INCLUDE_DIRS})
INCLUDE_DIRECTORIES(${K3D_GLIBMM_INCLUDE_DIRS})
INCLUDE_DIRECTORIES(${K3D_SIGC_INCLUDE_DIRS})

LINK_DIRECTORIES(${K3D_BOOST_LIB_DIRS})
LINK_DIRECTORIES(${K3D_GLIBMM_LIB_DIRS})
LINK_DIRECTORIES(${K3D_SIGC_LIB_DIRS})

ADD_EXECUTABLE(k3d-renderjob main.cpp)
TARGET_LINK_LIBRARIES(k3d-renderjob k3dsdk)
IF(WIN32 AND K3D_COMPILER_GCC)
	SET_TARGET_PROPERTIES(k3d-renderjob PROPERTIES LINK_FLAGS -mwindows)
ENDIF(WIN32 AND K3D_COMPILER_GCC)

INSTALL(TARGETS k3d-renderjob DESTINATION bin)

=== resource-compiler/CMakeLists.txt ===
PROJECT(k3d-resource-compiler)

INCLUDE_DIRECTORIES(${K3D_BOOST_INCLUDE_DIRS})
LINK_DIRECTORIES(${K3D_BOOST_LIB_DIRS})

ADD_EXECUTABLE(k3d-resource-compiler main.cpp)
TARGET_LINK_LIBRARIES(k3d-resource-compiler ${K3D_BOOST_PROGRAM_OPTIONS_LIBS})

=== debian/changelog ===
k3d (0.8.0.2-9) unstable; urgency=low

  * Add '--remove-section=.note' when stripping *.module files
  * Changed debhelper compat to level 8 (level 7 before), no changes needed
  * Build-Depends on libjpeg-dev instead of libjpeg62-dev
  * Overriding lintian errors of embedded libraries while waiting for a reply
    from upstream, it's not straightforward to unravel:
    - 'embedded-library usr/lib/libk3dsdk-ftgl.so.1: ftgl'
    - 'embedded-library usr/lib/libk3dsdk-glew.so.1: glew'

 -- Manuel A. Fernandez Montecelo <manuel.montezelo@gmail.com>  Sun, 10 Jul 2011 01:09:00 +0200

k3d (0.8.0.2-8) unstable; urgency=low

  * Rebuild for imagemagick4 transition (Closes: #625576)
  * Bump Standards-Version to 3.9.2 (no changes needed)
  * Simplifying a lot debian/rules file by leveraging debhelper capabilities,
    only acting when deviating from auto behaviour

 -- Manuel A. Fernandez Montecelo <manuel.montezelo@gmail.com>  Sat, 28 May 2011 03:21:18 +0200

k3d (0.8.0.2-7) unstable; urgency=low

  * Remove build dependency on libopencascade-dev, since the opencascade module
    uses k3d::gprim_factory which has been removed, and thus it's not enabled at
    build time anyway (Closes: #616668).  Thanks Denis Barbier for the heads-up.
  * Seems to build fine on GCC-4.5 (Closes: #565008), default compiler on
    unstable at this time (on most architectures, anyway).  The problem was most
    likely occuring in libsigc++-2.0 for some reason, and has been fixed since
    then.

 -- Manuel A. Fernandez Montecelo <manuel.montezelo@gmail.com>  Wed, 13 Apr 2011 15:55:55 +0200

k3d (0.8.0.2-6) unstable; urgency=low

  * Adding .desktop file so it appears in menus

 -- Manuel A. Fernandez Montecelo <manuel.montezelo@gmail.com>  Fri, 07 Jan 2011 16:32:26 +0100

k3d (0.8.0.2-5) unstable; urgency=low

  * Using "dh_shlibdeps -a -- debian/k3d/usr/lib/k3d/plugins/*.module" to have
    shared lib dependencies right, so the module TimeSource (and others) do not
    fail to load when the program starts (Closes: #609200).  Thanks to Paul Wise
    <pabs@d.o> for the tip.
  * Change Build-Depends to depend on Boost >= 1.42 (were ">> 1.42" before,
    which do not exist, but were pulled in somehow, maybe by other dependencies)

 -- Manuel A. Fernandez Montecelo <manuel.montezelo@gmail.com>  Fri, 07 Jan 2011 12:31:08 +0100

k3d (0.8.0.2-4) unstable; urgency=low

  * Make libinotifytools-dev conditional with [!kfreebsd-i386 !kfreebsd-amd64
  !hurd-i386], it's not available in these architectures and [linux-any] does
  not work (Closes: #592532)

 -- Manuel A. Fernandez Montecelo <manuel.montezelo@gmail.com>  Fri, 13 Aug 2010 00:12:37 +0200

k3d (0.8.0.2-3) unstable; urgency=low

  * Bump Standards-Version to 3.9.1 (no changes needed)
  * Use Breaks and Replaces to allow for smooth upgrades without errors,
    caused by files from one package overriding others (Closes: #588604)
  * Change the package to priority "extra", optional is for "all the
    software that you might reasonably want to install if you didn't
    know what it was and don't have specialized requirements".  This is
    not the case, and additionally debcheck reports that it depends on
    software with "extra" priority (libxcb-render-util0), which should
    not happen.
  * Use -mlong-calls in addition to -ffunction-sections in HPPA,
    hopefully this time it will work fine (Closes: #588923)
  * Quell lintian:
    - quilt-patch-missing-description (bug_554930-ftbfs-gold.patch)
    - duplicate-short-description (k3d k3d-data)

 -- Manuel A. Fernandez Montecelo <manuel.montezelo@gmail.com>  Thu, 12 Aug 2010 13:32:42 +0200

k3d (0.8.0.2-2) unstable; urgency=low

  * Put myself in the Uploaders field, add DM-Upload-Allowed: yes
  * Added patch for FTBFS with binutils-gold (Closes: #554930)
  * Use Breaks instead of Conflicts (lintian: conflicts-with-version)
  * Create k3d-data binary package (lintian: arch-dep-package-has-big-usr-share)
  * Added --remove-section=.comment when stripping by hand (lintian:
    binary-has-unneeded-section)
  * Use special "CXXFLAGS += -ffunction-sections" on hppa architecture,
    otherwise the build fails at 17% (let's hope there're no more errors...).

 -- Manuel A. Fernandez Montecelo <manuel.montezelo@gmail.com>  Wed, 07 Jul 2010 02:08:31 +0200

k3d (0.8.0.2-1.1) unstable; urgency=low

  * Non-maintainer upload.
  * New upstream release (Closes: #581590).
    - Probably fixed the important bug during the 3 years since last
      release (Closes: #443684).
  * Updated man pages with 'help2man -N --no-discard-stderr"
  * Changed debhelper compat to level 7
  * Added 'watch' file
  * Added 'source/format', with '3.0 (quilt)'
  * Bump Standards-Version to 3.9.0
  * Quelling lintian warnings:
    - out-of-date-standards-version 3.8.0
    - package-uses-deprecated-debhelper-compat-version 4
    - patch-system-but-no-source-readme (now format 3.0 quilt)
    - copyright-refers-to-versionless-license-file (now pointing to GPL-2)
    - debhelper-but-no-misc-depends (added)
    - binary-without-manpage (added manpages)
    - duplicate-font-file (depend on ttf-bitstream-vera and symlink)
  * Dropped all patches:
    * applied upstream:
      - 03_desktop_file_compliant.patch
      - 08_sigc++_headers.patch
    * uses CMake instead of autotools, not applicable anymore:
      - 01_imagemagick_paths.patch
      - 02_boost-mt_libs.patch
      - 04_config.guess-sub_update.patch
    * new upstream doesn't need them:
      - 05_gcc4.3_build.patch
      - 07_gcc4.4_build.patch
    * file doesn't exist anymore:
      - 06_bashisms.patch

 -- Manuel A. Fernandez Montecelo <manuel.montezelo@gmail.com>  Wed, 30 Jun 2010 16:51:25 +0200

k3d (0.6.7.0-2.6) unstable; urgency=low

  * Non-maintainer upload.
  * Apply patch to fix FTBFS due to missing headers. (Closes: #571021)
    Thanks to Ilya Barygin <barygin@gmail.com> for the patch.

 -- Ana Beatriz Guerrero Lopez <ana@debian.org>  Sun, 21 Mar 2010 12:15:43 +0100



=== debian/control ===
Source: k3d
Section: graphics
Priority: extra
Maintainer: David Martínez Moreno <ender@debian.org>
Uploaders: Manuel A. Fernandez Montecelo <manuel.montezelo@gmail.com>
DM-Upload-Allowed: yes
Build-Depends: debhelper (>= 8.0.0), quilt, cmake (>> 2.6), pkg-config, zlib1g-dev, uuid-dev, libsigc++-2.0-dev, libglibmm-2.4-dev, libgtkmm-2.4-dev, libgnomevfs2-dev, libgtksourceview2.0-dev, libgtkglext1-dev, libcairomm-1.0-dev, libdbus-glib-1-dev, libinotifytools-dev [!kfreebsd-i386 !kfreebsd-amd64 !hurd-i386], libxml2-dev | libexpat1-dev, libfreetype6-dev, libboost-dev (>= 1.42), libboost-date-time-dev (>= 1.42), libboost-regex-dev (>= 1.42), libboost-program-options-dev (>= 1.42), libboost-test-dev (>= 1.42), libboost-python-dev (>= 1.42), libgl1-mesa-dev | libgl-dev, libglu1-mesa-dev | libglu-dev, libpng-dev, librsvg2-dev, libjpeg-dev, libopenexr-dev, libtiff4-dev, libmagick++-dev, lib3ds-dev, libgts-dev, python-dev, python-support, graphviz, libsuperlu3-dev, libode-dev, gettext, ttf-bitstream-vera (>= 1.10)
Standards-Version: 3.9.2
Homepage: http://www.k-3d.org/
Vcs-Hg: http://k3d.hg.sourceforge.net:8000/hgroot/k3d/k3d
Vcs-Browser: http://k3d.hg.sourceforge.net/hgweb/k3d/k3d/

Package: k3d
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, k3d-data (= ${source:Version})
Replaces: k3d-dev (<< 0.8.0.1)
Breaks: k3d-dev (<< 0.8.0.1)
Description: 3D modeling and animation system, binary files
 K-3D is free-as-in-freedom 3D modeling and animation software. It combines
 flexible plugins with a visualization pipeline architecture, making K-3D a
 versatile and powerful tool for artists.
 .
 This package contains binaries and libraries.

Package: k3d-data
Architecture: all
Replaces: k3d (<< 0.8.0.2-2)
Breaks: k3d (<< 0.8.0.2-2)
Depends: ${misc:Depends}
Description: 3D modeling and animation system, data files
 K-3D is free-as-in-freedom 3D modeling and animation software. It combines
 flexible plugins with a visualization pipeline architecture, making K-3D a
 versatile and powerful tool for artists.
 .
 This package contains data needed by the binaries (shaders, GUI elements, ...).

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# DEB_BUILD_OPTIONS
ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
        CXXFLAGS += -O0
else
        CXXFLAGS += -O2
endif
# DEB_BUILD_OPTIONS


# special issues on architectures
ifeq (hppa,$(DEB_BUILD_ARCH))
        CXXFLAGS += -ffunction-sections -mlong-calls
endif
# special issues on architectures


%:
	dh $@ --buildsystem=cmake --with quilt

override_dh_auto_configure:
	dh_auto_configure -- \
                -DCMAKE_CXX_FLAGS=$(CXXFLAGS) \
		-DCMAKE_VERBOSE_MAKEFILE:BOOL=OFF

override_dh_auto_build:
	dh_auto_build --parallel

override_dh_auto_install:
	dh_auto_install

#	Strip plugins and libraries, dh_link doesn't work with all of them
	find debian/tmp/usr/lib -name \*.module -exec strip --strip-unneeded --remove-section=.comment --remove-section=.note {} \;

#	Remove files, we're not going to ship them because it would be only
#	useful for plugin developers and upstream discourages it
	rm -fr debian/tmp/usr/include
	rm -f debian/tmp/usr/lib/*so

#	Quell lintian warning "duplicate-font-file" by removing the files and
#	symlinking to the ones in the package tff-bitstream-vera.  Use dh_link,
#	since paths must be relative when elements in the path are common
#	(e.g. /usr/)
	rm -f debian/tmp/usr/share/k3d/fonts/Vera*ttf

override_dh_shlibdeps:
	dh_shlibdeps -- debian/k3d/usr/lib/k3d/plugins/*.module
